void add_to_toolbar (GtkWidget *mainWin, gchar *tooltipText, 
		     gchar ** xpmIcon, GtkSignalFunc f, gpointer data,
		     GtkWidget *box, int Beginning) {

	GtkWidget *button, *gpixmap;
	GdkPixmap *pixmap;
	GdkBitmap *bitmap;
	GtkTooltips *tooltip;
	GtkStyle *style;

	if (f == NULL)
		button = gtk_label_new("     ");
	   else {
		button = gtk_button_new();
		tooltip = gtk_tooltips_new();
		gtk_tooltips_set_tip(tooltip,button,tooltipText, NULL);
		gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
				  f, (gpointer)data);
		style = gtk_widget_get_style(mainWin);
	        pixmap = gdk_pixmap_create_from_xpm_d(mainWin->window,&bitmap,
					     &style->bg[GTK_STATE_NORMAL],
					     xpmIcon);
		gpixmap = gtk_pixmap_new(pixmap,bitmap);
		gtk_widget_show(gpixmap);
		gtk_container_add(GTK_CONTAINER(button), gpixmap);
	}
	gtk_widget_show(button);
	if (Beginning)
		gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 0);
	   else
		gtk_box_pack_end(GTK_BOX(box), button, FALSE, FALSE, 0);
}

void create_toolbar (GtkWidget *box, GtkWidget *mainWin) {

	add_to_toolbar(mainWin, "Open Image", fileopen_xpm, 
		       GTK_SIGNAL_FUNC(filedialog), "o", box, 1);
	add_to_toolbar(mainWin, "Print Image", print_xpm, 
		       GTK_SIGNAL_FUNC(print_pic), NULL, box, 1);
	add_to_toolbar(mainWin, NULL, NULL, NULL, NULL, box, 1);

	add_to_toolbar(mainWin, "Get Index", getindex_xpm, 
		       GTK_SIGNAL_FUNC(getindex), NULL, box, 1);
	add_to_toolbar(mainWin, "Get Selected Images", getpic_xpm, 
		       GTK_SIGNAL_FUNC(getpics), NULL, box, 1);
	add_to_toolbar(mainWin, "Delete Selected Images", deletepic_xpm, 
		       GTK_SIGNAL_FUNC(del_dialog), NULL, box, 1);
	add_to_toolbar(mainWin, NULL, NULL, NULL, NULL, box, 1);

	add_to_toolbar(mainWin, "Camera Configuration", cameraconfig_xpm, 
		       GTK_SIGNAL_FUNC(configure_call), NULL, box, 1);

	add_to_toolbar(mainWin, NULL, NULL, NULL, NULL, box, 1);
	add_to_toolbar(mainWin, NULL, NULL, NULL, NULL, box, 1);
	add_to_toolbar(mainWin, "Rotate Clockwise", rotc_xpm,
		       GTK_SIGNAL_FUNC(manip_pic), "r", box, 1);
	add_to_toolbar(mainWin, "Rotate Counter-Clockwise", rotcc_xpm,
		       GTK_SIGNAL_FUNC(manip_pic), "l", box, 1);
	add_to_toolbar(mainWin, "Flip Horizontal", fliph_xpm,
		       GTK_SIGNAL_FUNC(manip_pic), "h", box, 1);
	add_to_toolbar(mainWin, "Flip Vertical", flipv_xpm,
		       GTK_SIGNAL_FUNC(manip_pic), "v", box, 1);
	add_to_toolbar(mainWin, "Resize", resize_xpm,
		       GTK_SIGNAL_FUNC(resize_dialog),
			"Resize", box, 1);

}
